=== db/example/Makefile ===
# $Id: Makefile,v 1.1 2002/07/09 09:08:25 janakj Rel $
#
# database example module makefile
#
# 
# WARNING: do not run this directly, it should be run by the master Makefile

auto_gen=
NAME=dbexample.so
LIBS=

include ../../Makefile.modules
