=== modules/extcmd/Makefile ===
# $Id: Makefile,v 1.2 2003/05/23 15:43:43 andrei Exp $
#
# example module makefile
#
# 
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=extcmd.so
LIBS=

include ../../Makefile.modules
