=== modules/nathelper/Makefile ===
# $Id: Makefile,v 1.2.6.1 2003/11/24 14:00:34 janakj Exp $
#
# print example module makefile
#
# 
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=nathelper.so
LIBS=

include ../../Makefile.modules
