=== modules/sl/Makefile ===
# $Id: Makefile,v 1.3 2003/05/23 15:43:44 andrei Exp $
#
# example module makefile
#
# 
# WARNING: do not run this directly, it should be run by the master Makefile

include ../../Makefile.defs
auto_gen=
NAME=sl.so
LIBS= 

include ../../Makefile.modules
